Index: uspace/srv/net/tcp/test/tqueue.c
===================================================================
--- uspace/srv/net/tcp/test/tqueue.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/srv/net/tcp/test/tqueue.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,262 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+//#include <inet/endpoint.h>
+#include <io/log.h>
+#include <pcut/pcut.h>
+
+#include "../conn.h"
+#include "../tqueue.h"
+
+PCUT_INIT
+
+PCUT_TEST_SUITE(tqueue);
+
+enum {
+	test_seg_max = 10
+};
+
+static int seg_cnt;
+static tcp_segment_t *trans_seg[test_seg_max];
+
+static void tqueue_test_transmit_seg(inet_ep2_t *, tcp_segment_t *);
+
+static tcp_tqueue_cb_t tqueue_test_cb = {
+	.transmit_seg = tqueue_test_transmit_seg
+};
+
+PCUT_TEST_BEFORE
+{
+	int rc;
+
+	/* We will be calling functions that perform logging */
+	rc = log_init("test-tcp");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = tcp_conns_init();
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+PCUT_TEST_AFTER
+{
+	tcp_conns_fini();
+}
+
+
+/** Test  */
+PCUT_TEST(init_fini)
+{
+	tcp_conn_t *conn;
+	inet_ep2_t epp;
+
+	/* XXX tqueue can only be created via tcp_conn_new */
+	inet_ep2_init(&epp);
+	conn = tcp_conn_new(&epp);
+	PCUT_ASSERT_NOT_NULL(conn);
+
+	/* Redirect segment transmission */
+	conn->retransmit.cb = &tqueue_test_cb;
+	seg_cnt = 0;
+
+	tcp_conn_lock(conn);
+	tcp_conn_reset(conn);
+	tcp_conn_unlock(conn);
+	tcp_conn_delete(conn);
+	PCUT_ASSERT_EQUALS(0, seg_cnt);
+}
+
+/** Test sending control segment and tearing down a non-empty queue */
+PCUT_TEST(ctrl_seg_teardown)
+{
+	tcp_conn_t *conn;
+	inet_ep2_t epp;
+
+	/* XXX tqueue can only be created via tcp_conn_new */
+	inet_ep2_init(&epp);
+	conn = tcp_conn_new(&epp);
+	PCUT_ASSERT_NOT_NULL(conn);
+
+	conn->snd_nxt = 10;
+
+	/* Redirect segment transmission */
+	conn->retransmit.cb = &tqueue_test_cb;
+	seg_cnt = 0;
+
+	tcp_conn_lock(conn);
+	tcp_tqueue_ctrl_seg(conn, CTL_SYN);
+	tcp_conn_reset(conn);
+	tcp_conn_unlock(conn);
+	PCUT_ASSERT_EQUALS(11, conn->snd_nxt);
+
+	tcp_conn_delete(conn);
+	PCUT_ASSERT_EQUALS(1, seg_cnt);
+	PCUT_ASSERT_EQUALS(CTL_SYN, trans_seg[0]->ctrl);
+	PCUT_ASSERT_EQUALS(10, trans_seg[0]->seq);
+}
+
+/** Test sending data and FIN */
+PCUT_TEST(new_data_fin)
+{
+	tcp_conn_t *conn;
+	inet_ep2_t epp;
+	int i;
+
+	/* XXX tqueue can only be created via tcp_conn_new */
+	inet_ep2_init(&epp);
+	conn = tcp_conn_new(&epp);
+	PCUT_ASSERT_NOT_NULL(conn);
+
+	conn->cstate = st_established;
+	conn->snd_una = 10;
+	conn->snd_nxt = 10;
+	conn->snd_wnd = 1024;
+	conn->snd_buf_used = 20;
+	conn->snd_buf_fin = true;
+	for (i = 0; i < 20; i++)
+		conn->snd_buf[i] = i;
+
+	/* Redirect segment transmission */
+	conn->retransmit.cb = &tqueue_test_cb;
+	seg_cnt = 0;
+
+	tcp_conn_lock(conn);
+	tcp_tqueue_new_data(conn);
+	tcp_conn_reset(conn);
+	tcp_conn_unlock(conn);
+	PCUT_ASSERT_EQUALS(31, conn->snd_nxt);
+	PCUT_ASSERT_EQUALS(0, conn->snd_buf_used);
+	PCUT_ASSERT_FALSE(conn->snd_buf_fin);
+
+	tcp_conn_delete(conn);
+	PCUT_ASSERT_EQUALS(1, seg_cnt);
+	PCUT_ASSERT_EQUALS(CTL_FIN | CTL_ACK, trans_seg[0]->ctrl);
+	PCUT_ASSERT_EQUALS(10, trans_seg[0]->seq);
+}
+
+/** Test sending data when send window is smaller */
+PCUT_TEST(new_data_small_win)
+{
+	tcp_conn_t *conn;
+	inet_ep2_t epp;
+	int i;
+
+	/* XXX tqueue can only be created via tcp_conn_new */
+	inet_ep2_init(&epp);
+	conn = tcp_conn_new(&epp);
+	PCUT_ASSERT_NOT_NULL(conn);
+
+	conn->cstate = st_established;
+	conn->snd_una = 10;
+	conn->snd_nxt = 10;
+	conn->snd_wnd = 5;
+	conn->snd_buf_used = 30;
+	conn->snd_buf_fin = false;
+	for (i = 0; i < 30; i++)
+		conn->snd_buf[i] = i;
+
+	/* Redirect segment transmission */
+	conn->retransmit.cb = &tqueue_test_cb;
+	seg_cnt = 0;
+
+	tcp_conn_lock(conn);
+	tcp_tqueue_new_data(conn);
+	tcp_conn_reset(conn);
+	tcp_conn_unlock(conn);
+
+	PCUT_ASSERT_EQUALS(15, conn->snd_nxt);
+	PCUT_ASSERT_EQUALS(25, conn->snd_buf_used);
+	PCUT_ASSERT_FALSE(conn->snd_buf_fin);
+	for (i = 0; i < 25; i++)
+		PCUT_ASSERT_INT_EQUALS(5 + i, conn->snd_buf[i]);
+
+	tcp_conn_delete(conn);
+	PCUT_ASSERT_EQUALS(1, seg_cnt);
+	PCUT_ASSERT_EQUALS(CTL_ACK, trans_seg[0]->ctrl);
+	PCUT_ASSERT_EQUALS(10, trans_seg[0]->seq);
+}
+
+/** Test flushing tqueue due to receiving an ACK */
+PCUT_TEST(ack_received)
+{
+	tcp_conn_t *conn;
+	inet_ep2_t epp;
+	int i;
+
+	/* XXX tqueue can only be created via tcp_conn_new */
+	inet_ep2_init(&epp);
+	conn = tcp_conn_new(&epp);
+	PCUT_ASSERT_NOT_NULL(conn);
+
+	conn->cstate = st_established;
+	conn->snd_una = 10;
+	conn->snd_nxt = 10;
+	conn->snd_wnd = 1024;
+
+	/* Redirect segment transmission */
+	conn->retransmit.cb = &tqueue_test_cb;
+	seg_cnt = 0;
+
+	tcp_conn_lock(conn);
+
+	/* Queue first data segment */
+	conn->snd_buf_used = 10;
+	conn->snd_buf_fin = false;
+	for (i = 0; i < 10; i++)
+		conn->snd_buf[i] = i;
+	tcp_tqueue_new_data(conn);
+
+	PCUT_ASSERT_EQUALS(20, conn->snd_nxt);
+
+	/* Queue second data segment */
+	conn->snd_buf_used = 20;
+	conn->snd_buf_fin = false;
+	for (i = 0; i < 20; i++)
+		conn->snd_buf[i] = i;
+	tcp_tqueue_new_data(conn);
+
+	PCUT_ASSERT_EQUALS(40, conn->snd_nxt);
+
+	PCUT_ASSERT_INT_EQUALS(2, list_count(&conn->retransmit.list));
+
+	/* One of the two segments is acked */
+	conn->snd_una = 20;
+	tcp_tqueue_ack_received(conn);
+
+	PCUT_ASSERT_INT_EQUALS(1, list_count(&conn->retransmit.list));
+
+	tcp_conn_reset(conn);
+	tcp_conn_unlock(conn);
+	tcp_conn_delete(conn);
+}
+
+static void tqueue_test_transmit_seg(inet_ep2_t *epp, tcp_segment_t *seg)
+{
+	trans_seg[seg_cnt++] = seg;
+}
+
+PCUT_EXPORT(tqueue);
Index: uspace/srv/net/tcp/test/ucall.c
===================================================================
--- uspace/srv/net/tcp/test/ucall.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/srv/net/tcp/test/ucall.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,316 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <inet/endpoint.h>
+#include <io/log.h>
+#include <pcut/pcut.h>
+
+#include "../conn.h"
+#include "../rqueue.h"
+#include "../ucall.h"
+
+PCUT_INIT
+
+PCUT_TEST_SUITE(ucall);
+
+static void test_cstate_change(tcp_conn_t *, void *, tcp_cstate_t);
+static void test_conns_establish(tcp_conn_t **, tcp_conn_t **);
+static void test_conns_tear_down(tcp_conn_t *, tcp_conn_t *);
+
+static tcp_rqueue_cb_t test_rqueue_cb = {
+	.seg_received = tcp_as_segment_arrived
+};
+
+static tcp_cb_t test_conn_cb = {
+	.cstate_change = test_cstate_change
+};
+
+static tcp_conn_status_t cconn_status;
+static tcp_conn_status_t sconn_status;
+
+static FIBRIL_MUTEX_INITIALIZE(cst_lock);
+static FIBRIL_CONDVAR_INITIALIZE(cst_cv);
+
+PCUT_TEST_BEFORE
+{
+	int rc;
+
+	/* We will be calling functions that perform logging */
+	rc = log_init("test-tcp");
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = tcp_conns_init();
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	tcp_rqueue_init(&test_rqueue_cb);
+	tcp_rqueue_fibril_start();
+
+	/* Enable internal loopback */
+	tcp_conn_lb = tcp_lb_segment;
+}
+
+PCUT_TEST_AFTER
+{
+	tcp_rqueue_fini();
+	tcp_conns_fini();
+}
+
+/** Test creating a listening passive connection and then deleting it. */
+PCUT_TEST(listen_delete)
+{
+	tcp_conn_t *conn;
+	inet_ep2_t epp;
+	tcp_error_t trc;
+	tcp_conn_status_t cstatus;
+
+	inet_ep2_init(&epp);
+	inet_addr(&epp.local.addr, 127, 0, 0, 1);
+	epp.local.port = inet_port_user_lo;
+
+	conn = NULL;
+	trc = tcp_uc_open(&epp, ap_passive, tcp_open_nonblock, &conn);
+	PCUT_ASSERT_INT_EQUALS(TCP_EOK, trc);
+	PCUT_ASSERT_NOT_NULL(conn);
+
+	tcp_uc_status(conn, &cstatus);
+	PCUT_ASSERT_INT_EQUALS(st_listen, cstatus.cstate);
+
+	trc = tcp_uc_close(conn);
+	PCUT_ASSERT_INT_EQUALS(TCP_EOK, trc);
+	tcp_uc_delete(conn);
+}
+
+/** Test trying to connect to endpoint that sends RST back */
+PCUT_TEST(connect_rst)
+{
+	tcp_conn_t *conn;
+	inet_ep2_t epp;
+	tcp_error_t trc;
+
+	inet_ep2_init(&epp);
+	inet_addr(&epp.local.addr, 127, 0, 0, 1);
+	inet_addr(&epp.remote.addr, 127, 0, 0, 1);
+	epp.remote.port = inet_port_user_lo;
+
+	conn = NULL;
+	trc = tcp_uc_open(&epp, ap_active, 0, &conn);
+	PCUT_ASSERT_INT_EQUALS(TCP_ERESET, trc);
+	PCUT_ASSERT_NULL(conn);
+}
+
+/** Test establishing a connection */
+PCUT_TEST(conn_establish)
+{
+	tcp_conn_t *cconn, *sconn;
+
+	test_conns_establish(&cconn, &sconn);
+	test_conns_tear_down(cconn, sconn);
+}
+
+/** Test establishing and then closing down a connection first on one side,
+ * then on_the other. */
+PCUT_TEST(conn_est_close_seq)
+{
+	tcp_conn_t *cconn, *sconn;
+	tcp_error_t trc;
+
+	log_msg(LOG_DEFAULT, LVL_NOTE, "conn_est_close_seq: establish");
+	/* Establish */
+	test_conns_establish(&cconn, &sconn);
+
+	log_msg(LOG_DEFAULT, LVL_NOTE, "conn_est_close_seq: close cconn");
+	/* Close client side */
+	trc = tcp_uc_close(cconn);
+	PCUT_ASSERT_INT_EQUALS(TCP_EOK, trc);
+
+	log_msg(LOG_DEFAULT, LVL_NOTE, "conn_est_close_seq: wait cconn = fin-wait-2");
+	/* Wait for cconn to go to Fin-Wait-2 */
+	fibril_mutex_lock(&cst_lock);
+	tcp_uc_status(cconn, &cconn_status);
+	while (cconn_status.cstate != st_fin_wait_2)
+		fibril_condvar_wait(&cst_cv, &cst_lock);
+	fibril_mutex_unlock(&cst_lock);
+
+	log_msg(LOG_DEFAULT, LVL_NOTE, "conn_est_close_seq: wait sconn = close-wait");
+	/* Wait for sconn to go to Close-Wait */
+	fibril_mutex_lock(&cst_lock);
+	tcp_uc_status(sconn, &sconn_status);
+	while (sconn_status.cstate != st_close_wait)
+		fibril_condvar_wait(&cst_cv, &cst_lock);
+	fibril_mutex_unlock(&cst_lock);
+
+	log_msg(LOG_DEFAULT, LVL_NOTE, "conn_est_close_seq: close sconn");
+	/* Close server side */
+	trc = tcp_uc_close(sconn);
+	PCUT_ASSERT_INT_EQUALS(TCP_EOK, trc);
+
+	log_msg(LOG_DEFAULT, LVL_NOTE, "conn_est_close_seq: wait cconn = time-wait");
+	/* Wait for cconn to go to Time-Wait */
+	fibril_mutex_lock(&cst_lock);
+	tcp_uc_status(cconn, &cconn_status);
+	while (cconn_status.cstate != st_time_wait)
+		fibril_condvar_wait(&cst_cv, &cst_lock);
+	fibril_mutex_unlock(&cst_lock);
+
+	log_msg(LOG_DEFAULT, LVL_NOTE, "conn_est_close_seq: wait sconn = closed");
+	/* Wait for sconn to go to Closed */
+	fibril_mutex_lock(&cst_lock);
+	tcp_uc_status(sconn, &sconn_status);
+	while (sconn_status.cstate != st_closed) {
+		log_msg(LOG_DEFAULT, LVL_NOTE, "conn_est_close_seq: sconn.status == %d", sconn_status.cstate);
+		fibril_condvar_wait(&cst_cv, &cst_lock);
+	}
+	fibril_mutex_unlock(&cst_lock);
+
+	log_msg(LOG_DEFAULT, LVL_NOTE, "conn_est_close_seq: tear down");
+	/* Tear down */
+	test_conns_tear_down(cconn, sconn);
+}
+
+/** Test establishing and then simultaneously closing down a connection. */
+PCUT_TEST(conn_est_close_simult)
+{
+	tcp_conn_t *cconn, *sconn;
+	tcp_error_t trc;
+
+	/* Establish */
+	test_conns_establish(&cconn, &sconn);
+
+	/* Close both sides simultaneously */
+	trc = tcp_uc_close(cconn);
+	PCUT_ASSERT_INT_EQUALS(TCP_EOK, trc);
+	trc = tcp_uc_close(sconn);
+	PCUT_ASSERT_INT_EQUALS(TCP_EOK, trc);
+
+	/* Wait for cconn to go to Time-Wait */
+	fibril_mutex_lock(&cst_lock);
+	tcp_uc_status(cconn, &cconn_status);
+	while (cconn_status.cstate != st_time_wait)
+		fibril_condvar_wait(&cst_cv, &cst_lock);
+	fibril_mutex_unlock(&cst_lock);
+
+	/*
+	 * Wait for sconn to go to Closed or Time-Wait. The connection
+	 * goes to Closed if we managed to call tcp_uc_close() before
+	 * sconn received FIN. Otherwise it goes to Time-Wait.
+	 *
+	 * XXX We may want to add delay to the loopback here to be
+	 * absolutely sure that we go to Closing -> Time-Wait.
+	 */
+	fibril_mutex_lock(&cst_lock);
+	tcp_uc_status(sconn, &sconn_status);
+	while (sconn_status.cstate != st_time_wait &&
+	    sconn_status.cstate != st_closed)
+		fibril_condvar_wait(&cst_cv, &cst_lock);
+	fibril_mutex_unlock(&cst_lock);
+
+	/* Tear down */
+	test_conns_tear_down(cconn, sconn);
+}
+
+static void test_cstate_change(tcp_conn_t *conn, void *arg,
+    tcp_cstate_t old_state)
+{
+	tcp_conn_status_t *status = (tcp_conn_status_t *)arg;
+
+	fibril_mutex_lock(&cst_lock);
+	tcp_uc_status(conn, status);
+	fibril_mutex_unlock(&cst_lock);
+	fibril_condvar_broadcast(&cst_cv);
+}
+
+/** Establish client-server connection */
+static void test_conns_establish(tcp_conn_t **rcconn, tcp_conn_t **rsconn)
+{
+	tcp_conn_t *cconn, *sconn;
+	inet_ep2_t cepp, sepp;
+	tcp_conn_status_t cstatus;
+	tcp_error_t trc;
+
+	/* Client EPP */
+	inet_ep2_init(&cepp);
+	inet_addr(&cepp.local.addr, 127, 0, 0, 1);
+	inet_addr(&cepp.remote.addr, 127, 0, 0, 1);
+	cepp.remote.port = inet_port_user_lo;
+
+	/* Server EPP */
+	inet_ep2_init(&sepp);
+	inet_addr(&sepp.local.addr, 127, 0, 0, 1);
+	sepp.local.port = inet_port_user_lo;
+
+	/* Server side of the connection */
+	sconn = NULL;
+	trc = tcp_uc_open(&sepp, ap_passive, tcp_open_nonblock, &sconn);
+	PCUT_ASSERT_INT_EQUALS(TCP_EOK, trc);
+	PCUT_ASSERT_NOT_NULL(sconn);
+
+	tcp_uc_set_cb(sconn, &test_conn_cb, &sconn_status);
+	PCUT_ASSERT_EQUALS(&sconn_status, tcp_uc_get_userptr(sconn));
+
+	tcp_uc_status(sconn, &cstatus);
+	PCUT_ASSERT_INT_EQUALS(st_listen, cstatus.cstate);
+
+	/* Client side of the connection */
+
+	cconn = NULL;
+	trc = tcp_uc_open(&cepp, ap_active, 0, &cconn);
+	PCUT_ASSERT_INT_EQUALS(TCP_EOK, trc);
+	PCUT_ASSERT_NOT_NULL(cconn);
+
+	tcp_uc_set_cb(cconn, &test_conn_cb, &cconn_status);
+	PCUT_ASSERT_EQUALS(&cconn_status, tcp_uc_get_userptr(cconn));
+
+	/* The client side of the connection should be established by now */
+
+	tcp_uc_status(cconn, &cstatus);
+	PCUT_ASSERT_INT_EQUALS(st_established, cstatus.cstate);
+
+	/* Need to wait for server side */
+
+	fibril_mutex_lock(&cst_lock);
+	tcp_uc_status(sconn, &sconn_status);
+	while (sconn_status.cstate != st_established)
+		fibril_condvar_wait(&cst_cv, &cst_lock);
+	fibril_mutex_unlock(&cst_lock);
+
+	*rcconn = cconn;
+	*rsconn = sconn;
+}
+
+/* Tear down client-server connection. */
+static void test_conns_tear_down(tcp_conn_t *cconn, tcp_conn_t *sconn)
+{
+	tcp_uc_abort(cconn);
+	tcp_uc_delete(cconn);
+
+	tcp_uc_abort(sconn);
+	tcp_uc_delete(sconn);
+}
+
+PCUT_EXPORT(ucall);
Index: uspace/srv/net/tcp/tqueue.c
===================================================================
--- uspace/srv/net/tcp/tqueue.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/tqueue.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -43,24 +43,30 @@
 #include <mem.h>
 #include <stdlib.h>
+
 #include "conn.h"
+#include "inet.h"
 #include "ncsim.h"
-#include "pdu.h"
 #include "rqueue.h"
 #include "segment.h"
 #include "seq_no.h"
 #include "tqueue.h"
-#include "tcp.h"
 #include "tcp_type.h"
 
 #define RETRANSMIT_TIMEOUT	(2*1000*1000)
 
-static void retransmit_timeout_func(void *arg);
-static void tcp_tqueue_timer_set(tcp_conn_t *conn);
-static void tcp_tqueue_timer_clear(tcp_conn_t *conn);
-
-int tcp_tqueue_init(tcp_tqueue_t *tqueue, tcp_conn_t *conn)
+static void retransmit_timeout_func(void *);
+static void tcp_tqueue_timer_set(tcp_conn_t *);
+static void tcp_tqueue_timer_clear(tcp_conn_t *);
+static void tcp_tqueue_seg(tcp_conn_t *, tcp_segment_t *);
+static void tcp_conn_transmit_segment(tcp_conn_t *, tcp_segment_t *);
+static void tcp_prepare_transmit_segment(tcp_conn_t *, tcp_segment_t *);
+static void tcp_tqueue_send_immed(tcp_conn_t *, tcp_segment_t *);
+
+int tcp_tqueue_init(tcp_tqueue_t *tqueue, tcp_conn_t *conn,
+    tcp_tqueue_cb_t *cb)
 {
 	tqueue->conn = conn;
 	tqueue->timer = fibril_timer_create(&conn->lock);
+	tqueue->cb = cb;
 	if (tqueue->timer == NULL)
 		return ENOMEM;
@@ -78,8 +84,20 @@
 void tcp_tqueue_fini(tcp_tqueue_t *tqueue)
 {
+	link_t *link;
+	tcp_tqueue_entry_t *tqe;
+
 	if (tqueue->timer != NULL) {
 		fibril_timer_destroy(tqueue->timer);
 		tqueue->timer = NULL;
 	}
+
+	while (!list_empty(&tqueue->list)) {
+		link = list_first(&tqueue->list);
+		tqe = list_get_instance(link, tcp_tqueue_entry_t, link);
+		list_remove(link);
+
+		tcp_segment_delete(tqe->seg);
+		free(tqe);
+	}
 }
 
@@ -87,4 +105,6 @@
 {
 	tcp_segment_t *seg;
+
+	assert(fibril_mutex_is_locked(&conn->lock));
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_tqueue_ctrl_seg(%p, %u)", conn, ctrl);
@@ -95,8 +115,10 @@
 }
 
-void tcp_tqueue_seg(tcp_conn_t *conn, tcp_segment_t *seg)
+static void tcp_tqueue_seg(tcp_conn_t *conn, tcp_segment_t *seg)
 {
 	tcp_segment_t *rt_seg;
 	tcp_tqueue_entry_t *tqe;
+
+	assert(fibril_mutex_is_locked(&conn->lock));
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "%s: tcp_tqueue_seg(%p, %p)", conn->name, conn,
@@ -135,5 +157,5 @@
 }
 
-void tcp_prepare_transmit_segment(tcp_conn_t *conn, tcp_segment_t *seg)
+static void tcp_prepare_transmit_segment(tcp_conn_t *conn, tcp_segment_t *seg)
 {
 	/*
@@ -267,5 +289,5 @@
 }
 
-void tcp_conn_transmit_segment(tcp_conn_t *conn, tcp_segment_t *seg)
+static void tcp_conn_transmit_segment(tcp_conn_t *conn, tcp_segment_t *seg)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "%s: tcp_conn_transmit_segment(%p, %p)",
@@ -279,12 +301,12 @@
 		seg->ack = 0;
 
-	tcp_transmit_segment(&conn->ident, seg);
-}
-
-void tcp_transmit_segment(inet_ep2_t *epp, tcp_segment_t *seg)
+	tcp_tqueue_send_immed(conn, seg);
+}
+
+void tcp_tqueue_send_immed(tcp_conn_t *conn, tcp_segment_t *seg)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG,
-	    "tcp_transmit_segment(l:(%u),f:(%u), %p)",
-	    epp->local.port, epp->remote.port, seg);
+	    "tcp_tqueue_send_immed(l:(%u),f:(%u), %p)",
+	    conn->ident.local.port, conn->ident.remote.port, seg);
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "SEG.SEQ=%" PRIu32 ", SEG.WND=%" PRIu32,
@@ -292,20 +314,6 @@
 
 	tcp_segment_dump(seg);
-/*
-	tcp_pdu_prepare(conn, seg, &data, &len);
-	tcp_pdu_transmit(data, len);
-*/
-//	tcp_rqueue_bounce_seg(sp, seg);
-//	tcp_ncsim_bounce_seg(sp, seg);
-
-	tcp_pdu_t *pdu;
-
-	if (tcp_pdu_encode(epp, seg, &pdu) != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Not enough memory. Segment dropped.");
-		return;
-	}
-
-	tcp_transmit_pdu(pdu);
-	tcp_pdu_delete(pdu);
+
+	conn->retransmit.cb->transmit_seg(&conn->ident, seg);
 }
 
@@ -362,4 +370,6 @@
 static void tcp_tqueue_timer_set(tcp_conn_t *conn)
 {
+	assert(fibril_mutex_is_locked(&conn->lock));
+
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "### %s: tcp_tqueue_timer_set() begin", conn->name);
 
@@ -377,4 +387,6 @@
 static void tcp_tqueue_timer_clear(tcp_conn_t *conn)
 {
+	assert(fibril_mutex_is_locked(&conn->lock));
+
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "### %s: tcp_tqueue_timer_clear() begin", conn->name);
 
Index: uspace/srv/net/tcp/tqueue.h
===================================================================
--- uspace/srv/net/tcp/tqueue.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/tqueue.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,16 +40,11 @@
 #include "tcp_type.h"
 
-extern int tcp_tqueue_init(tcp_tqueue_t *, tcp_conn_t *);
+extern int tcp_tqueue_init(tcp_tqueue_t *, tcp_conn_t *,
+    tcp_tqueue_cb_t *);
 extern void tcp_tqueue_clear(tcp_tqueue_t *);
 extern void tcp_tqueue_fini(tcp_tqueue_t *);
 extern void tcp_tqueue_ctrl_seg(tcp_conn_t *, tcp_control_t);
-extern void tcp_tqueue_seg(tcp_conn_t *, tcp_segment_t *);
 extern void tcp_tqueue_new_data(tcp_conn_t *);
 extern void tcp_tqueue_ack_received(tcp_conn_t *);
-extern void tcp_prepare_transmit_segment(tcp_conn_t *, tcp_segment_t *);
-extern void tcp_conn_transmit_segment(tcp_conn_t *, tcp_segment_t *);
-extern void tcp_transmit_segment(inet_ep2_t *, tcp_segment_t *);
-extern void tcp_header_setup(tcp_conn_t *, tcp_segment_t *, tcp_header_t *);
-extern void tcp_phdr_setup(tcp_conn_t *, tcp_segment_t *, tcp_phdr_t *);
 
 #endif
Index: uspace/srv/net/tcp/ucall.c
===================================================================
--- uspace/srv/net/tcp/ucall.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/tcp/ucall.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -108,4 +108,5 @@
 		assert(nconn->cstate == st_closed);
 		tcp_conn_unlock(nconn);
+		tcp_conn_delete(nconn);
 		return TCP_ERESET;
 	}
@@ -280,4 +281,8 @@
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_uc_abort()");
+
+	tcp_conn_lock(conn);
+	tcp_conn_reset(conn);
+	tcp_conn_unlock(conn);
 }
 
Index: uspace/srv/net/udp/assoc.c
===================================================================
--- uspace/srv/net/udp/assoc.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/udp/assoc.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,4 +40,5 @@
 #include <fibril_synch.h>
 #include <inet/endpoint.h>
+#include <inet/inet.h>
 #include <io/log.h>
 #include <nettl/amap.h>
@@ -261,7 +262,20 @@
 		return EINVAL;
 
+	/* This association has no local address set. Need to determine one. */
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_send - check no local addr");
+	if (inet_addr_is_any(&epp.local.addr) && !assoc->nolocal) {
+		log_msg(LOG_DEFAULT, LVL_DEBUG, "Determine local address.");
+		rc = inet_get_srcaddr(&epp.remote.addr, 0, &epp.local.addr);
+		if (rc != EOK) {
+			log_msg(LOG_DEFAULT, LVL_DEBUG, "Cannot determine "
+			    "local address.");
+			return EINVAL;
+		}
+	}
+
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_send - check version");
 
-	if (epp.remote.addr.version != epp.local.addr.version)
+	if (!inet_addr_is_any(&epp.local.addr) &&
+	    epp.remote.addr.version != epp.local.addr.version)
 		return EINVAL;
 
Index: uspace/srv/net/udp/service.c
===================================================================
--- uspace/srv/net/udp/service.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/udp/service.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -270,4 +270,28 @@
 }
 
+/** Set association sending messages with no local address.
+ *
+ * Handle client request to set nolocal flag (with parameters unmarshalled).
+ *
+ * @param client   UDP client
+ * @param assoc_id Association ID
+ * @return EOK on success, ENOENT if no such association is found
+ */
+static int udp_assoc_set_nolocal_impl(udp_client_t *client, sysarg_t assoc_id)
+{
+	udp_cassoc_t *cassoc;
+	int rc;
+
+	rc = udp_cassoc_get(client, assoc_id, &cassoc);
+	if (rc != EOK) {
+		assert(rc == ENOENT);
+		return ENOENT;
+	}
+
+	log_msg(LOG_DEFAULT, LVL_NOTE, "Setting nolocal to true");
+	cassoc->assoc->nolocal = true;
+	return EOK;
+}
+
 /** Send message via association.
  *
@@ -391,4 +415,25 @@
 	assoc_id = IPC_GET_ARG1(*icall);
 	rc = udp_assoc_destroy_impl(client, assoc_id);
+	async_answer_0(iid, rc);
+}
+
+/** Set association with no local address.
+ *
+ * Handle client request to set no local address flag.
+ *
+ * @param client   UDP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
+static void udp_assoc_set_nolocal_srv(udp_client_t *client, ipc_callid_t iid,
+    ipc_call_t *icall)
+{
+	sysarg_t assoc_id;
+	int rc;
+
+	log_msg(LOG_DEFAULT, LVL_NOTE, "udp_assoc_set_nolocal_srv()");
+
+	assoc_id = IPC_GET_ARG1(*icall);
+	rc = udp_assoc_set_nolocal_impl(client, assoc_id);
 	async_answer_0(iid, rc);
 }
@@ -662,4 +707,7 @@
 			udp_assoc_destroy_srv(&client, callid, &call);
 			break;
+		case UDP_ASSOC_SET_NOLOCAL:
+			udp_assoc_set_nolocal_srv(&client, callid, &call);
+			break;
 		case UDP_ASSOC_SEND_MSG:
 			udp_assoc_send_msg_srv(&client, callid, &call);
Index: uspace/srv/net/udp/udp_inet.c
===================================================================
--- uspace/srv/net/udp/udp_inet.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/udp/udp_inet.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,11 +35,7 @@
  */
 
-#include <bitops.h>
-#include <byteorder.h>
 #include <errno.h>
 #include <inet/inet.h>
 #include <io/log.h>
-#include <stdio.h>
-#include <task.h>
 
 #include "assoc.h"
Index: uspace/srv/net/udp/udp_type.h
===================================================================
--- uspace/srv/net/udp/udp_type.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/net/udp/udp_type.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,4 +41,5 @@
 #include <inet/endpoint.h>
 #include <ipc/loc.h>
+#include <stdbool.h>
 #include <stddef.h>
 #include <inet/addr.h>
@@ -119,4 +120,6 @@
 	/** Receive queue CV. Broadcast when new datagram is inserted */
 	fibril_condvar_t rcv_queue_cv;
+	/** Allow sending messages with no local address */
+	bool nolocal;
 
 	udp_assoc_cb_t *cb;
Index: uspace/srv/ns/clonable.c
===================================================================
--- uspace/srv/ns/clonable.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/ns/clonable.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -31,5 +31,5 @@
  */
 
-#include <ipc/ipc.h>
+#include <async.h>
 #include <ipc/services.h>
 #include <adt/list.h>
@@ -81,5 +81,5 @@
 		/* There was no pending connection request. */
 		printf("%s: Unexpected clonable server.\n", NAME);
-		ipc_answer_0(callid, EBUSY);
+		async_answer_0(callid, EBUSY);
 		return;
 	}
@@ -91,11 +91,17 @@
 	assert(csr->service == SERVICE_LOADER);
 	
-	ipc_answer_0(callid, EOK);
+	async_answer_0(callid, EOK);
 	
-	ipc_forward_fast(csr->callid, phone, csr->iface, csr->arg3, 0,
+	async_sess_t *sess = async_callback_receive(EXCHANGE_SERIALIZE);
+	if (sess == NULL)
+		async_answer_0(callid, EIO);
+	
+	async_exch_t *exch = async_exchange_begin(sess);
+	async_forward_fast(csr->callid, exch, csr->iface, csr->arg3, 0,
 	    IPC_FF_NONE);
+	async_exchange_end(exch);
 	
 	free(csr);
-	ipc_hangup(phone);
+	async_hangup(sess);
 }
 
@@ -117,5 +123,5 @@
 	cs_req_t *csr = malloc(sizeof(cs_req_t));
 	if (csr == NULL) {
-		ipc_answer_0(callid, ENOMEM);
+		async_answer_0(callid, ENOMEM);
 		return;
 	}
@@ -126,5 +132,5 @@
 	if (rc < 0) {
 		free(csr);
-		ipc_answer_0(callid, rc);
+		async_answer_0(callid, rc);
 		return;
 	}
